//! Piping buffered data from a raw socket to `ESock`
//!
//! This exists because i'm too dumb to implement a functional AsyncRead/Write buffered wrapper stream :/
use super::*;
use std::{
    io,
    marker::{
	Send, Sync,
	
	Unpin,
	PhantomData,
    },
};
use futures::{
    Future,
};
use tokio::sync::{
    mpsc,
};
use enc::{
    ESock,
    
    ESockReadHalf,
    ESockWriteHalf,
};

/// The default buffer size for `BufferedESock`.
pub const DEFAULT_BUFFER_SIZE: usize = 32;

/// Task-based buffered piping to/from encrypted sockets.
pub struct BufferedESock<W, R>
{
    
    bufsz: usize,
    _backing: PhantomData<ESock<W, R>>,
}

/// `tx`: ESock-wrapped network output socket.
/// `rx`: Reading half of the user's fake stream
//TODO: Maybe we can get away with using `DuplexStream` instead of a generic for `Fake`. But we don't want to give any illusions that that stream can be written to, so I think making it opaque with a generic is fine.
fn bsock_writer<'a, Raw, Fake>(mut tx: ESockWriteHalf<Raw>, mut rx: Fake) -> impl Future<Output = ()> + 'a
where Raw: AsyncWrite + Unpin + 'a,
Fake: AsyncRead + Unpin + 'a,
{
    async move {
	
    }
}

/// `rx`: Raw, unencrypted network input socket
/// `tx`: Writing half of the user's `ESockReadHalf`'s rx stream, which wraps the receiver from this fake sender stream.
//TODO: Maybe we can get away with using `DuplexStream` instead of a generic for `Fake`. But we don't want to give any illusions that that stream can be read from, so I think making it opaque with a generic is fine.
fn bsock_reader<'a, Raw, Fake>(mut rx: Raw, mut tx: Fake) -> impl Future<Output= ()> + 'a
where Raw: AsyncRead + Unpin + 'a,
      Fake: AsyncWrite + Unpin + 'a
{
    async move {
	
    }
}


impl<W, R> BufferedESock<W, R>
where W: AsyncWrite + Unpin + Send + 'static,
      R: AsyncRead + Unpin + Send + 'static
{
    /// Create a new buffered ESock pipe with a specific buffer size
    pub fn with_size(tx: W, rx: R, bufsz: usize) -> Self
    {
	
	Self {
	    bufsz,
	    _backing: PhantomData,
	}
    }

    /// Create a new buffered ESock pipe with the default buffer size (`DEFAULT_BUFFER_SIZE`).
    #[inline] pub fn new(tx: W, rx: R) -> Self
    {
	Self::with_size(tx, rx, DEFAULT_BUFFER_SIZE)
    }
}
